blog/config/routes.rb
Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
  root "articles#index"
  
  # get "/articles", to: "articles#index" #old get route
  # get "articles/:id", to: "articles#show" #old get route
  resources :articles do
    resources :comments
  end
end

blog/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

blog/app/models/article.rb
class Article < ApplicationRecord
    include Visible

    has_many :comments, dependent: :destroy

    validates :title, presence: true
    validates :body, presence: true, length: { minimum: 10 }
end

blog/app/models/comment.rb
class Comment < ApplicationRecord
  include Visible

  belongs_to :article
end

blog/app/models/concerns/visible.rb
module Visible
    extend ActiveSupport::Concern

    VALID_STATUSES = ['public', 'private', 'archived']

    included do
        validates :status, inclusion: { in: VALID_STATUSES }
    end

    class_methods do
        def public_count
            where(status: 'public').count
        end
    end

    def archived?
        status == 'archived'
    end
end

blog/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

blog/app/controllers/articles_controller.rb
class ArticlesController < ApplicationController

  http_basic_authenticate_with name: "dhh", password: "secret", except: [:index, :show]

  def index
    @articles = Article.all
  end

  def show
    @article = Article.find(params[:id])
  end

  def new
    @article = Article.new
  end

  def create
    @article = Article.new(article_params)

    if @article.save
      redirect_to @article
    else
      render :new, status: :unprocessable_entity
    end
  end

  def edit
    @article = Article.find(params[:id])
  end

  def update
    @article = Article.find(params[:id])

    if @article.update(article_params)
      redirect_to @article
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    redirect_to root_path, status: :see_other
  end

  private
    def article_params
      params.require(:article).permit(:title, :body, :status)
    end
end

blog/app/controllers/comments_controller.rb
class CommentsController < ApplicationController

    http_basic_authenticate_with name: "dhh", password: "secret", only: :destroy

    def create
        @article = Article.find(params[:article_id])
        @comment = @article.comments.create(comment_params)
        redirect_to article_path(@article)
    end

    def destroy
        @article = Article.find(params[:article_id])
        @comment = @article.comments.find(params[:id])
        @comment.destroy
        redirect_to article_path(@article), status: :see_other
    end

    private
        def comment_params
            params.require(:comment).permit(:commenter, :body, :status)
        end
end

blog/app/helpers/application_helper.rb
module ApplicationHelper
end

blog/app/helpers/articles_helper.rb
module ArticlesHelper
end

blog/app/helpers/comments_helper.rb
module CommentsHelper
end

blog/app/views/articles/_form.html.erb
<%= form_with model: article do |form| %>
    <div>
        <%= form.label :title %><br>
        <%= form.text_field :title %>
        <% article.errors.full_messages_for(:title).each do |message| %>
            <div><%= message %></div>
        <% end %>
    </div>

    <div>
        <%= form.label :body %><br>
        <%= form.text_area :body %><br>
        <% article.errors.full_messages_for(:body).each do |message| %>
            <div><%= message %></div>
        <% end %>
    </div>

    <div>
        <%= form.label :status %><br>
        <%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
    </div>

    <div>
        <%= form.submit %>
    </div>
<% end %>

blog/app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<%= render "form", article: @article %>

blog/app/views/articles/index.html.erb
<h1>Articles</h1>

Our blog has <%= Article.public_count %> articles and counting!

<ul>
    <% @articles.each do |article| %>
        <% unless article.archived? %>
            <li>
                <%= link_to article.title, article %>
            </li>
        <% end %>
    <% end %>
</ul>

<%= link_to "New Article", new_article_path %>

blog/app/views/articles/new.html.erb
<h1>New Article</h1>

<%= render "form", article: @article %>

blog/app/views/articles/show.html.erb
<h1><%= @article.title %></h1>

<p><%= @article.body %></p>

<ul>
    <li><%= link_to "Edit", edit_article_path(@article) %></li>
    <li><%= link_to "Destroy", article_path(@article), data: {
        turbo_method: :delete,
        turbo_confirm: "Are you sure?"
    } %></li>
</ul>

<h2>Comments</h2>
<%= render @article.comments %>

<h2>Add a comment:</h2>
<%= render 'comments/form' %>

blog/app/views/comments/_comment.html.erb
<% unless comment.archived? %>
    <p>
        <strong>Commenter:</strong>
        <%= comment.commenter %>
    </p>

    <p>
        <strong>Comment:</strong>
        <%= comment.body %>
    </p>

    <p>
        <%= link_to "Destroy Comment", [comment.article, comment], data: {
            turbo_method: :delete,
            turbo_confirm: "Are you sure?"
        } %>
    </p>
<% end %>

blog/app/views/comments/_form.html.erb
<%= form_with model: [ @article, @article.comments.build ] do |form| %>
    <p>
        <%= form.label :commenter %><br>
        <%= form.text_field :commenter %>
    </p>
    <p>
        <%= form.label :body %><br>
        <%= form.text_area :body %>
    </p>
    <p>
        <%= form.label :status %><br>
        <%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
    </p>
    <p>
        <%= form.submit %>
    </p>
<% end %>

blog/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>